<?php

/*
 * phpMyEzin - e-zin content management system
 *
 * subst.inc.php - template substitutions stuff
 * ____________________________________________________________
 *
 * Developed by Ondrej Jombik <nepto@platon.sk>
 * Copyright (c) 2001-2005 Platon SDG, http://platon.sk/
 * All rights reserved.
 *
 * See README file for more information about this software.
 * See COPYING file for license information.
 *
 * Download the latest version from
 * http://platon.sk/projects/phpMyEzin/
 */

/* $Platon: $ */

require_once 'config/loader.inc.php';
Platon::redirect_test(basename(__FILE__), $ezin_cfg['url']);
require_once 'error.inc.php';
require_once 'functions.inc.php';
require_once 'db-core/db-core.inc.php';
require_once 'db.inc.php';

/*
 * Include libraries
 */

require_once 'HTML/Template/Platon.php';
HTML_Template_Platon::setLoadFunction('ezin_load_template');

if (isset($ezin_sys['weblog']['dsn']) && strlen($ezin_sys['weblog']['dsn']) > 0) {
	include_once 'lib/phpWebLogAnalyzer/phpWebLogAnalyzer.inc.php';
	$ezin_weblog = new Web_Log($ezin_sys['weblog']['dsn']);
} else {
	$ezin_weblog = false;
}

/*
 * Input parameters parsing
 */

ezin_cgi_parse();
//var_dump($ezin_cgi);

/*
 * Write counts
 */

ezin_update_counts_temp();
ezin_update_counts($ezin_cgi['author_id'], $ezin_cgi['section_id'], $ezin_cgi['article_id']);

/*
 * Try include user defined functions
 */

if (file_exists($ezin_cfg['theme']['dir'].'/'.$ezin_sys['tmpl']['fnc_file'])) {
	include_once $ezin_cfg['theme']['dir'].'/'.$ezin_sys['tmpl']['fnc_file'];
}

/*
 * Get section parameters
 */

$ezin_tmpl_key   = '';
$ezin_db_author  = '';
$ezin_db_section = '';
$ezin_db_article = '';
if ($ezin_cgi['author_id'] > 0 || $ezin_cgi['output'] == 'author') {
	$ezin_db_author = ezin_get_author($ezin_cgi['author_id']);
	if (! empty($ezin_db_author['author_link']) && $ezin_cgi['output'] == 'author') {
		ezin_handle_author_link($ezin_db_author['author_link']);
	}
	$name = $ezin_db_author['author_name'];
	$ezin_db_author['search'] = $ezin_db_author['author_id'];
	if (strlen($name) > 0) {
		if (preg_match('|^(\S*)\s*(\S*)|', $name, $matches)) {
			$ezin_db_author['search'] = $matches[2];
		} else if (preg_match('|^(\S*),\s*(\S*)|', $name)) {
			$ezin_db_author['search'] = $matches[1];
		}
	}
} else if ($ezin_cgi['section_id'] > 0 || $ezin_cgi['output'] == 'section') {
	$ezin_db_section = ezin_get_section($ezin_cgi['section_id']);
	if (! empty($ezin_db_section['section_link']) && $ezin_cgi['output'] == 'section') {
		ezin_handle_section_link($ezin_db_section['section_link']);
		$ezin_db_section['section_editorial_text'] = Platon::tilde_replace(
				$ezin_db_section['section_editorial_text']);
	}

	if (! empty($ezin_cgi['article_id'])) {
		$ezin_db_article = ezin_get_article($ezin_cgi['article_id']);
		if (! empty($ezin_db_article['article_template_key'])) {
			$ezin_tmpl_key = $ezin_sys['tmpl']['delim'].$ezin_db_article['article_template_key'];
		}
	}
}


/*
 * Main template object
 */

switch ($ezin_cgi['output']) {
	default:
		die('input method fatal error: '.$ezin_cgi['output']);
		break;
	case 'error':
		$ezin_tmpl_main_fname  = $ezin_sys['tmpl']['error'];
		break;
	case 'notfound':
		$ezin_tmpl_main_fname  = $ezin_sys['tmpl']['notfound'];
		break;
	case 'admin':
		$ezin_tmpl_main_fname  = $ezin_sys['tmpl']['admin'];
		$ezin_tmpl_main_fname .= $ezin_sys['tmpl']['delim'];
		$ezin_tmpl_main_fname .= $ezin_auth->getAuth() && $ezin_admin_action != 'logout'
			? 'logged' : 'notlogged';
		break;
	case 'message':
		$ezin_tmpl_main_fname  = $ezin_sys['tmpl']['message_edit'].$ezin_tmpl_key;
		break;
	case 'message_full_list':
	case 'message_selected_list':
		$ezin_tmpl_main_fname  = $ezin_sys['tmpl']['message'].$ezin_tmpl_key;
		break;
	case 'article_print':
		$ezin_tmpl_main_fname  = $ezin_sys['tmpl']['article_print'].$ezin_tmpl_key;
		break;
	case 'article':
		$ezin_tmpl_main_fname  = $ezin_sys['tmpl']['article'].$ezin_tmpl_key;
		break;
	case 'section':
		$ezin_tmpl_main_fname  = $ezin_sys['tmpl']['section'];
		if (! empty($ezin_db_section['section_template_key'])) {
			$ezin_tmpl_main_fname .= $ezin_sys['tmpl']['delim']
				. $ezin_db_section['section_template_key'];
		if ($ezin_tmpl_key == '') {
				$ezin_tmpl_key = $ezin_sys['tmpl']['delim']
					. $ezin_db_section['section_template_key'];
			}
		}
		break;
	case 'author':
		if (strlen($ezin_tmpl_key) <= 0) {
			$ezin_tmpl_key = $ezin_sys['tmpl']['delim'].'author';
		}
		$ezin_tmpl_main_fname  = $ezin_sys['tmpl']['author'].$ezin_tmpl_key;
		break;
}

$ezin_tmpl_main = new HTML_Template_Platon($ezin_tmpl_main_fname);

/*
 * Substitute current section parameters
 */

if ($ezin_db_author != '') {
	ezin_author_link_process($ezin_db_author);
	ezin_author_counts_process($ezin_db_author);

	ezin_handle_special_tags($ezin_db_author['author_descrition'],
			$ezin_db_author['author_description_flags']);
	ezin_process_text_flags($ezin_db_author['author_description'], 'author');

	$ezin_tmpl_main->set($ezin_db_author);
}

if ($ezin_db_section != '') {
	ezin_section_link_process($ezin_db_section);
	ezin_section_counts_process($ezin_db_section);
	if (isset($ezin_db_section['section_editorial_timestamp'])) {
		$ezin_db_section['section_editorial_date'] =
			date($ezin_cfg['format_date'], $ezin_db_section['section_editorial_timestamp']);
		$ezin_db_section['section_editorial_datetime'] =
			date($ezin_cfg['format_datetime'], $ezin_db_section['section_editorial_timestamp']);
	} else {
		$ezin_db_section['section_editorial_date'] =
			$ezin_db_section['section_editorial_datetime'] = '';
	}

	if (isset($ezin_db_section['section_editorial_text'])) {
		ezin_handle_special_tags($ezin_db_section['section_editorial_text'],
				$ezin_db_section['section_editorial_text_flags']);
		ezin_process_text_flags($ezin_db_section['section_editorial_text'], 'editorial');
	} else {
		$ezin_db_section['section_editorial_text'] = '';
	}

	$ezin_tmpl_main->set($ezin_db_section);
}

/*
 * Build up sections list
 */

if ($ezin_tmpl_main->isVar('section_items')) {
	$cache_ar = ezin_cache_load('S'.@$ezin_cgi['lang']);
	if (intval($cache_ar['timestamp']) <= 0) {
		$item = new HTML_Template_Platon($ezin_sys['tmpl']['section_item'].$ezin_tmpl_key,
				HTML_TEMPLATE_PLATON_METHOD_VAR_KEEP);
		$cache_ar['var_var'] = $item->isVar('section_accesses_count')
							|| $item->isVar('section_raw_accesses_count') 
							|| $item->isVar('section_sessions_count')
							|| $item->isVar('section_raw_sessions_count');
		$sections = ezin_get_section_list($ezin_cgi['lang']);
		$cache_ar['content']    = '';

		for ($k = 0; $k < count($sections); $k++) {
			$item->reload();
			ezin_section_link_process($sections[$k]);
			ezin_section_counts_process($sections[$k]);
			$sections[$k]['section_selected'] = ($sections[$k]['section_id'] == $ezin_cgi['section_id']
					|| (empty($ezin_cgi['section_id']) && $sections[$k]['section_type'] == 'global'))
				? 1 : 0;
			if ($cache_ar['var_var']) {
				$id = $sections[$k]['section_id'];
				$item->setVar('section_accesses_count',     'section_accesses_count_'.$id);
				$item->setVar('section_sessions_count',     'section_sessions_count_'.$id);
				$item->setVar('section_raw_accesses_count', 'section_raw_accesses_count_'.$id);
				$item->setVar('section_raw_sessions_count', 'section_raw_sessions_count_'.$id);
			}
			$item->set($sections[$k]);
			$cache_ar['content'] .= $item->getCode();
		}
		//$cache_ar['content'] = Platon::tilde_replace($cache_ar['content']);
		unset($sections);
		ezin_cache_save('S'.@$ezin_cgi['lang'], $cache_ar['content'], $cache_ar['var_var']);
	}
	$ezin_tmpl_main->setCode('section_items', $cache_ar['content']);
	if ($cache_ar['var_var']) {
		$ezin_tmpl_main->set(ezin_get_section_list_counts($ezin_cgi['lang']));
	}
}

/*
 * Building articles list
 */

if ($ezin_tmpl_main->isVar('article_items') && ($ezin_db_section != '' || $ezin_db_author != '')) {
	$cache_id   = $ezin_db_section != '' ? 'S'.@$ezin_db_section['section_id'] : 'U'.@$ezin_db_author['author_id'];
	$cache_ar   = ezin_cache_load($cache_id);
	$section_id = $ezin_db_section != '' && $ezin_db_section['section_type'] != 'global' ? $ezin_db_section['section_id'] : 0;
	$author_id  = $ezin_db_author  != '' ? $ezin_db_author['search'] : '';
	$limit      = $ezin_db_section != '' ? intval($ezin_db_section['section_limit']) : 0;
	if (intval($cache_ar['timestamp']) <= 0) {
		$item = new HTML_Template_Platon($ezin_sys['tmpl']['article_item'].$ezin_tmpl_key);
		$cache_ar['var_var'] = $item->isVar('article_accesses_count')
							|| $item->isVar('article_sessions_count')
							|| $item->isVar('article_message_count');
		$articles = ezin_get_article_list($section_id, $author_id, $limit, $ezin_cgi['lang']);
		$cache_ar['content'] = '';

		for ($k = 0; $k < count($articles); $k++) {
			$item->reload();
			ezin_section_link_process($articles[$k], 'article_');
			ezin_author_link_process($articles[$k], 'article_');
			ezin_article_link_process($articles[$k]);
			ezin_article_counts_process($articles[$k]);
			ezin_handle_special_tags($articles[$k]['article_hometext'], $articles[$k]['article_hometext_flags']);
			ezin_process_text_flags($articles[$k]['article_hometext'], 'article_hometext');
			$articles[$k]['article_date']     = date($ezin_cfg['format_date'], $articles[$k]['article_timestamp']);
			$articles[$k]['article_datetime'] = date($ezin_cfg['format_datetime'], $articles[$k]['article_timestamp']);
			/* if atitle is empty, set it to title, but if title is empty, remains it unchanged */
			if (empty($articles[$k]['article_atitle']) && ! empty($articles[$k]['article_title']))
				$articles[$k]['article_atitle'] = $articles[$k]['article_title'];
			if ($cache_ar['var_var']) {
				$id = $articles[$k]['article_id'];
				$item->setVar('article_accesses_count', 'article_accesses_count_'.$id);
				$item->setVar('article_sessions_count', 'article_sessions_count_'.$id);
				$item->setVar('article_message_count',  'article_message_count_'.$id);
			}
			$item->set($articles[$k]);
			$cache_ar['content'] .= $item->getCode();
		}
		//$cache_ar['content'] = Platon::tilde_replace($cache_ar['content']);
		unset($articles);
		ezin_cache_save($cache_id, $cache_ar['content'], $cache_ar['var_var']);
	}

	$ezin_tmpl_main->setCode('article_items', $cache_ar['content']);
	if ($cache_ar['var_var']) {
		$ezin_tmpl_main->set(ezin_get_article_list_counts($section_id, $author_id, $limit, $ezin_cgi['lang']));
	}
}


/*
 * Gets and substitute current article parameters (if article is set)
 */

if ($ezin_db_article != '' && ! empty($ezin_cgi['article_id'])) {
	ezin_author_link_process($ezin_db_article, 'article_');
	ezin_section_link_process($ezin_db_article, 'article_');
	ezin_article_link_process($ezin_db_article);
	ezin_article_counts_process($ezin_db_article);
	ezin_handle_special_tags($ezin_db_article['article_hometext'], $ezin_db_article['article_hometext_flags']);
	ezin_handle_special_tags($ezin_db_article['article_bodytext'], $ezin_db_article['article_bodytext_flags']);
	ezin_process_text_flags($ezin_db_article['article_hometext'], 'article_hometext');
	ezin_process_text_flags($ezin_db_article['article_bodytext'], 'article_bodytext');
	$ezin_db_article['article_date']     = date($ezin_cfg['format_date'], $ezin_db_article['article_timestamp']);
	$ezin_db_article['article_datetime'] = date($ezin_cfg['format_datetime'], $ezin_db_article['article_timestamp']);

	/* if atitle is empty, set it to title, but if title is empty, remains it unchanged */
	if (empty($ezin_db_article['article_atitle']) && ! empty($ezin_db_article['article_title'])) {
		$ezin_db_article['article_atitle'] = $ezin_db_article['article_title'];
	}

	$ezin_tmpl_main->set($ezin_db_article);

	/*
	 * Build message list for current article.
	 */

	/* EXTREMLY IMPROTANT!!! */
	/* FIX THIS!!! empty content cosidered as false!! */
	/* OK, done, delete this comment after spring 2005 */

	if ($ezin_tmpl_main->isVar('message_items')) {
		if ($ezin_cgi['output'] == 'message_selected_list') { // selected lists are not cached
			$items = ezin_message_process(0, 0, 0);
		} else if (($items = ezin_cache_load_content('a'.@$ezin_db_article['article_id'])) === false) {
			$items = ezin_message_process(0, 0, 0);
			ezin_cache_save('a'.@$ezin_db_article['article_id'], $items);
		}
		$ezin_tmpl_main->setCode('message_items', $items);
	}

	if ($ezin_tmpl_main->isVar('message_full_items')) {
		if ($ezin_cgi['output'] == 'message_selected_list') { // selected lists are not cached
			$items = ezin_message_process(1, 0, 0);
		} else if (($items = ezin_cache_load_content('A'.@$ezin_db_article['article_id'])) === false) {
			$items = ezin_message_process(1, 0, 0);
			ezin_cache_save('A'.@$ezin_db_article['article_id'], $items);
		}
		$ezin_tmpl_main->setCode('message_full_items', $items);
	}
}

/*
 * Gets and substitute current message parameters (if message is set)
 */

if (! is_array($ezin_cgi['message_id']) && ! empty($ezin_cgi['message_id'])) {
	$ezin_db_message = ezin_get_message($ezin_cgi['message_id']);

	ezin_handle_special_tags($ezin_db_message['message_article_bodytext'], $ezin_db_message['message_article_bodytext_flags']);
	ezin_handle_special_tags($ezin_db_message['message_article_hometext'], $ezin_db_message['message_article_hometext_flags']);
	ezin_process_text_flags($ezin_db_message['message_message'], 'message');
	ezin_process_text_flags($ezin_db_message['message_article_hometext'], 'article_hometext');
	ezin_process_text_flags($ezin_db_message['message_article_bodytext'], 'article_bodytext');
	$ezin_db_message['message_date']     = date($ezin_cfg['format_date'], $ezin_db_message['message_timestamp']);
	$ezin_db_message['message_datetime'] = date($ezin_cfg['format_datetime'], $ezin_db_message['message_timestamp']);

	$ezin_tmpl_main->set($ezin_db_message);

	if (strlen(trim(@$ezin_cgi['message_reply_subject'])) <= 0) {
		$ezin_cgi['message_reply_subject'] = $ezin_db_message['message_subject'];
		if (strncasecmp('RE:', $ezin_cgi['message_reply_subject'], 3))
			$ezin_cgi['message_reply_subject'] = 'RE: ' . $ezin_cgi['message_reply_subject'];
	}
} else {
	$ezin_tmpl_main->set('message_id', '');
}

if ($ezin_cgi['output'] == 'message') {
	$ezin_tmpl_main->set(array(
		// Message reply fields
		'message_reply_subject'  => @$ezin_cgi['message_reply_subject'],
		'message_reply_message'  => @$ezin_cgi['message_reply_message'],
		'message_reply_author'   => isset($ezin_cgi['message_reply_author'])
		? $ezin_cgi['message_reply_author'] : @$_COOKIE['ezin_author_cookie'],
		'message_reply_email'    => isset($ezin_cgi['message_reply_email'])
		? $ezin_cgi['message_reply_email'] : @$_COOKIE['ezin_email_cookie'],
		'message_reply_homepage' => isset($ezin_cgi['message_reply_homepage'])
		? $ezin_cgi['message_reply_homepage'] : (isset($_COOKIE['ezin_homepage_cookie'])
			? $_COOKIE['ezin_homepage_cookie'] : 'http://'),

		// Message save flags
		'message_save_ok'               => intval(@$ezin_cgi['message_save_ok']),
		'message_save_error'            => intval(@$ezin_cgi['message_save_error']),
		'message_save_unknown_error'    => intval(@$ezin_cgi['message_save_unknown_error']),
		'message_save_flood_protection' => intval(@$ezin_cgi['message_save_flood_protection']),
		'message_save_subject_missing'  => intval(@$ezin_cgi['message_save_subject_missing']),
		'message_save_author_missing'   => intval(@$ezin_cgi['message_save_author_missing']),
		'message_save_message_missing'  => intval(@$ezin_cgi['message_save_message_missing']),
				));
}

ezin_substitute_basic_properties($ezin_tmpl_main);

?>
